sample_taggit/library_management/urls.py
from django.urls import path

from .views import (
    AuthorDetailView,
    AuthorListView,
    AuthorUpdateView,
    BookCreateView,
    BookDetailView,
    BookListView,
    BookUpdateView,
    MagazineCreateView,
    MagazineDetailView,
    MagazineListView,
    MagazineUpdateView,
    PhysicalCopyUpdateView,
    home_page,
)

urlpatterns = [
    path("", home_page, name="home_page"),
    path("book_list", BookListView.as_view(), name="book-list"),
    path("book/<int:pk>/", BookDetailView.as_view(), name="book-detail"),
    path("book/new/", BookCreateView.as_view(), name="book-create"),
    path("book/<int:pk>/edit/", BookUpdateView.as_view(), name="book-update"),
    path("authors/", AuthorListView.as_view(), name="author-list"),
    path("authors/<int:pk>/", AuthorDetailView.as_view(), name="author-detail"),
    path("authors/<int:pk>/edit/", AuthorUpdateView.as_view(), name="author-update"),
    path("magazines/", MagazineListView.as_view(), name="magazine-list"),
    path("magazine/<int:pk>/", MagazineDetailView.as_view(), name="magazine-detail"),
    path("magazine/new/", MagazineCreateView.as_view(), name="magazine-create"),
    path(
        "magazine/<int:pk>/edit/", MagazineUpdateView.as_view(), name="magazine-update"
    ),
    path(
        "physical_copy/<int:pk>/edit/",
        PhysicalCopyUpdateView.as_view(),
        name="physical-copy-update",
    ),
]

sample_taggit/urls.py
from django.contrib import admin
from django.urls import include, path
from library_management import urls as library_management_urls

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include(library_management_urls)),
]

sample_taggit/library_management/models.py
import uuid

from django.db import models
from django.urls import reverse

from taggit.managers import TaggableManager
from taggit.models import TagBase, TaggedItemBase


class BookTypeChoices(models.TextChoices):
    HARDCOVER = "HC", "Hardcover"
    PAPERBACK = "PB", "Paperback"
    EBOOK = "EB", "E-book"
    AUDIOBOOK = "AB", "Audiobook"
    MAGAZINE = "MG", "Magazine"


class BookType(TagBase):
    name = models.CharField(max_length=255, unique=True)

    class Meta:
        verbose_name = "Book Type"
        verbose_name_plural = "Book Types"


class Book(models.Model):
    name = models.CharField(max_length=255)
    author = models.ForeignKey("Author", on_delete=models.CASCADE)
    published_date = models.DateField(null=True)
    isbn = models.CharField(max_length=17, unique=True)
    summary = models.TextField()
    tags = TaggableManager()

    @property
    def title(self):
        return self.name

    def __str__(self):
        return self.title

    class Meta:
        verbose_name = "Book"
        verbose_name_plural = "Books"


class MagazineManager(models.Manager):
    def get_queryset(self):
        return (
            super()
            .get_queryset()
            .filter(
                physical_copies__book_type__name="Magazine",
                physical_copies__isnull=False,
            )
            .distinct()
        )


class Magazine(Book):
    objects = MagazineManager()

    class Meta:
        proxy = True

    @property
    def title(self):
        return f"{self.name} Edition: {self.published_date.strftime('%B %Y')}"


class Author(models.Model):
    first_name = models.CharField(max_length=255, blank=True)
    last_name = models.CharField(max_length=255, blank=True)
    middle_name = models.CharField(max_length=255, blank=True)
    birth_date = models.DateField()
    biography = models.TextField()
    tags = TaggableManager()

    @property
    def full_name(self):
        return f"{self.first_name} {self.last_name}"

    def get_absolute_url(self):
        return reverse("author-detail", kwargs={"pk": self.pk})

    def __str__(self):
        return self.full_name


class ConditionTag(TagBase):
    class Meta:
        verbose_name = "Condition Tag"
        verbose_name_plural = "Condition Tags"
        ordering = ["name"]


class ConditionTaggedItem(TaggedItemBase):
    tag = models.ForeignKey(
        ConditionTag, related_name="tagged_items", on_delete=models.CASCADE
    )
    content_object = models.ForeignKey("PhysicalCopy", on_delete=models.CASCADE)

    class Meta:
        verbose_name = "Condition Tagged Item"
        verbose_name_plural = "Condition Tagged Items"


class PhysicalCopy(models.Model):
    book = models.ForeignKey(
        Book, on_delete=models.CASCADE, related_name="physical_copies"
    )
    barcode = models.UUIDField(unique=True, default=uuid.uuid4, editable=False)
    book_type = models.ForeignKey(BookType, on_delete=models.CASCADE)
    condition_tags = TaggableManager(through=ConditionTaggedItem, blank=True)

    def __str__(self):
        return f"{self.book.name} - {self.barcode}"

    class Meta:
        verbose_name = "Physical Copy"
        verbose_name_plural = "Physical Copies"

sample_taggit/library_management/forms.py
from django import forms

from taggit.models import Tag

from .models import Author, Book, ConditionTag, PhysicalCopy


class PhysicalCopyForm(forms.ModelForm):
    condition_tags = forms.ModelMultipleChoiceField(
        queryset=ConditionTag.objects.all(),
        widget=forms.CheckboxSelectMultiple,
        required=False,
    )

    class Meta:
        model = PhysicalCopy
        fields = ["condition_tags"]


class AuthorForm(forms.ModelForm):
    tags = forms.ModelMultipleChoiceField(
        queryset=Tag.objects.all(), widget=forms.CheckboxSelectMultiple, required=False
    )

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields["tags"].queryset = self.fields["tags"].queryset.order_by("name")

    class Meta:
        model = Author
        fields = [
            "first_name",
            "last_name",
            "middle_name",
            "birth_date",
            "biography",
            "tags",
        ]


class BookForm(forms.ModelForm):
    tags = forms.ModelMultipleChoiceField(
        queryset=Tag.objects.all(), widget=forms.CheckboxSelectMultiple, required=False
    )

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields["tags"].queryset = self.fields["tags"].queryset.order_by("name")

    class Meta:
        model = Book
        fields = ["name", "author", "published_date", "isbn", "summary", "tags"]

sample_taggit/library_management/views.py
from django.db.models import Count
from django.db.models.functions import Lower
from django.shortcuts import render
from django.urls import reverse, reverse_lazy
from django.views.generic import CreateView, DetailView, ListView, UpdateView

from .forms import AuthorForm, BookForm, PhysicalCopyForm
from .models import Author, Book, Magazine, PhysicalCopy


def home_page(request):
    # Number of books
    num_books = Book.objects.count()

    # Different genres represented
    genres = Book.tags.values("name").annotate(count=Count("name")).order_by("-count")

    # Condition of physical books
    condition_stats = (
        PhysicalCopy.objects.values("condition_tags__name")
        .annotate(count=Count("condition_tags"))
        .order_by("-count")
    )

    context = {
        "num_books": num_books,
        "genres": genres,
        "condition_stats": condition_stats,
    }

    return render(request, "library_management/home_page.html", context)


class BookListView(ListView):
    model = Book
    template_name = "library_management/book_list.html"
    context_object_name = "books"
    paginate_by = 20

    def get_ordering(self):
        ordering = self.request.GET.get("ordering", "name")
        if ordering == "name":
            return [Lower("name")]
        return [ordering]


class BookDetailView(DetailView):
    model = Book
    template_name = "library_management/book_detail.html"
    context_object_name = "book"


class BookCreateView(CreateView):
    model = Book
    template_name = "library_management/book_form.html"
    fields = ["name", "author", "published_date", "isbn", "summary", "tags"]
    success_url = reverse_lazy("book-list")


class BookUpdateView(UpdateView):
    model = Book
    form_class = BookForm
    template_name = "library_management/book_form.html"

    def get_success_url(self):
        return reverse("book-detail", kwargs={"pk": self.object.pk})


class AuthorListView(ListView):
    model = Author
    template_name = "library_management/author_list.html"
    context_object_name = "authors"
    ordering = ["last_name", "first_name"]


class AuthorDetailView(DetailView):
    model = Author
    template_name = "library_management/author_detail.html"
    context_object_name = "author"


class AuthorUpdateView(UpdateView):
    model = Author
    form_class = AuthorForm
    template_name = "library_management/author_form.html"
    context_object_name = "author"


class MagazineListView(BookListView):
    model = Magazine
    template_name = "library_management/magazine_list.html"
    context_object_name = "magazines"


class MagazineDetailView(BookDetailView):
    model = Magazine
    template_name = "library_management/book_detail.html"
    context_object_name = "book"


class MagazineCreateView(BookCreateView):
    model = Magazine
    template_name = "library_management/book_form.html"
    success_url = reverse_lazy("magazine-list")


class MagazineUpdateView(BookUpdateView):
    model = Magazine
    form_class = BookForm
    template_name = "library_management/book_form.html"
    context_object_name = "book"

    def get_success_url(self):
        return reverse("magazine-detail", kwargs={"pk": self.object.pk})


class PhysicalCopyUpdateView(UpdateView):
    model = PhysicalCopy
    form_class = PhysicalCopyForm
    template_name = "library_management/physical_copy_form.html"

    def get_success_url(self):
        return reverse("book-detail", kwargs={"pk": self.object.book.pk})

sample_taggit/library_management/templates/library_management/author_detail.html
{% extends "library_management/base.html" %}
{% load custom_filters %}

{% block title %}Author Detail{% endblock %}

{% block content %}
<h1 class="my-4">{{ author.full_name }}</h1>
<p><strong>Birth Date:</strong> {{ author.birth_date }}</p>
<p>{{ author.biography }}</p>
<h2>Tags</h2>
<ul>
    {% for tag in author.tags.all|order_tags %}
    <li>{{ tag.name }}</li>
    {% endfor %}
</ul>
<h2>Books</h2>
<ul>
    {% for book in author.book_set.all %}
    <li><a href="{% url 'book-detail' book.pk %}">{{ book.name }}</a></li>
    {% endfor %}
</ul>
<a href="{% url 'author-list' %}" class="btn btn-secondary">Back to list</a>
<a href="{% url 'author-update' author.pk %}" class="btn btn-primary">Edit Author</a>
{% endblock %}

sample_taggit/library_management/templates/library_management/author_form.html
{% extends "library_management/base.html" %}

{% block title %}Edit Author{% endblock %}

{% block content %}
<h1 class="my-4">Edit Author</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit" class="btn btn-primary">Save changes</button>
    <a href="{% url 'author-detail' author.pk %}" class="btn btn-secondary">Cancel</a>
</form>
{% endblock %}

sample_taggit/library_management/templates/library_management/author_list.html
{% extends "library_management/base.html" %}

{% block title %}Authors{% endblock %}

{% block content %}
<h1 class="my-4">Authors</h1>
<ul>
    {% for author in authors %}
    <li><a href="{{ author.get_absolute_url }}">{{ author.full_name }}</a></li>
    {% endfor %}
</ul>
{% endblock %}

sample_taggit/library_management/templates/library_management/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% block title %}Library Management{% endblock %}</title>
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    {% block extra_css %}{% endblock %}
    <style>
        .navbar {
            background-color: #343a40;
        }
        .navbar-brand, .nav-link {
            color: #ffffff !important;
        }
        .nav-link:hover {
            color: #d4d4d4 !important;
        }
    </style>


</head>
<body>
    <nav class="navbar navbar-expand-lg">
    <a class="navbar-brand" href="{% url 'home_page' %}">Library Management</a>
    <div class="collapse navbar-collapse">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item">
                <a class="nav-link" href="{% url 'book-list' %}">Books</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="{% url 'author-list' %}">Authors</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="{% url 'magazine-list' %}">Magazines</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="{% url 'admin:index' %}">Admin</a>
            </li>
        </ul>
    </div>
</nav>
    <div class="container mt-4">
        {% block content %}{% endblock %}
    </div>
    {% block extra_js %}{% endblock %}
</body>
</html>

sample_taggit/library_management/templates/library_management/book_detail.html
{% extends "library_management/base.html" %}
{% load custom_filters %}


{% block title %}Book Detail{% endblock %}

{% block content %}
<h1 class="my-4">{{ book }}</h1>
<p><strong>Author:</strong> <a href="{{ book.author.get_absolute_url }}">{{ book.author.full_name }}</a></p>
<p><strong>Published Date:</strong> {{ book.published_date }}</p>
<p><strong>ISBN:</strong> {{ book.isbn }}</p>
<p><strong>Summary:</strong> {{ book.summary }}</p>
<p><strong>Tags:</strong> {{ book.tags.all|join:", " }}</p>

<h2 class="my-4">Physical Copies</h2>
<ul class="list-group">
    {% for copy in book.physical_copies.all %}
    <li class="list-group-item">
        <strong>Type:</strong> {{ copy.book_type.name }}<br>
        <strong>Condition:</strong> {{ copy.condition_tags.all|join:", " }}<br>
        <a href="{% url 'physical-copy-update' copy.pk %}" class="btn btn-primary">Update Condition</a>
    </li>
    {% endfor %}
</ul>

<a href="{% url 'book-list' %}" class="btn btn-secondary">Back to list</a>
{% if book|classname == 'Book' %}
<a href="{% url 'book-update' book.pk %}" class="btn btn-primary">Edit</a>
{% elif book|classname == 'Magazine' %}
<a href="{% url 'magazine-update' book.pk %}" class="btn btn-primary">Edit</a>
{% endif %}
{% endblock %}

sample_taggit/library_management/templates/library_management/book_form.html
{% extends "library_management/base.html" %}

{% block title %}Edit Book{% endblock %}

{% block content %}
<h1 class="my-4">Edit Book</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit" class="btn btn-primary">Save changes</button>
    <a href="{% url 'book-detail' book.pk %}" class="btn btn-secondary">Cancel</a>
</form>
{% endblock %}

sample_taggit/library_management/templates/library_management/book_list.html
{% extends "library_management/base.html" %}

{% block title %}Book List{% endblock %}

{% block content %}
<h1 class="my-4">Book List</h1>
<ul class="list-group">
    {% for book in page_obj %}
        <li class="list-group-item">
            <a href="{% url 'book-detail' book.pk %}">{{ book.name }}</a> by {{ book.author }}
        </li>
    {% endfor %}
</ul>

<nav aria-label="Page navigation">
    <ul class="pagination">
        {% if page_obj.has_previous %}
            <li class="page-item">
                <a class="page-link" href="?page=1" aria-label="First">
                    <span aria-hidden="true">&laquo;&laquo;</span>
                </a>
            </li>
            <li class="page-item">
                <a class="page-link" href="?page={{ page_obj.previous_page_number }}" aria-label="Previous">
                    <span aria-hidden="true">&laquo;</span>
                </a>
            </li>
        {% endif %}
        {% for num in page_obj.paginator.page_range %}
            {% if page_obj.number == num %}
                <li class="page-item active"><span class="page-link">{{ num }}</span></li>
            {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
                <li class="page-item"><a class="page-link" href="?page={{ num }}">{{ num }}</a></li>
            {% endif %}
        {% endfor %}
        {% if page_obj.has_next %}
            <li class="page-item">
                <a class="page-link" href="?page={{ page_obj.next_page_number }}" aria-label="Next">
                    <span aria-hidden="true">&raquo;</span>
                </a>
            </li>
            <li class="page-item">
                <a class="page-link" href="?page={{ page_obj.paginator.num_pages }}" aria-label="Last">
                    <span aria-hidden="true">&raquo;&raquo;</span>
                </a>
            </li>
        {% endif %}
    </ul>
</nav>
{% endblock %}

sample_taggit/library_management/templates/library_management/home_page.html
{% extends 'library_management/base.html' %}

{% block content %}
<h1 class="my-4">Library Management Home</h1>

<div class="row">
    <div class="col-md-4">
        <div class="card mb-4">
            <div class="card-body">
                <h5 class="card-title">Number of Books</h5>
                <p class="card-text"><strong>{{ num_books }}</strong></p>
            </div>
        </div>
    </div>
    <div class="col-md-4">
        <div class="card mb-4">
            <div class="card-body">
                <h5 class="card-title">Genres Represented</h5>
                <ul class="list-group list-group-flush">
                    {% for genre in genres %}
                        <li class="list-group-item">{{ genre.name }}: <strong>{{ genre.count }}</strong></li>
                    {% endfor %}
                </ul>
            </div>
        </div>
    </div>
    <div class="col-md-4">
        <div class="card mb-4">
            <div class="card-body">
                <h5 class="card-title">Condition of Physical Books</h5>
                <ul class="list-group list-group-flush">
                    {% for condition in condition_stats %}
                        <li class="list-group-item">{{ condition.condition_tags__name }}: <strong>{{ condition.count }}</strong></li>
                    {% endfor %}
                </ul>
            </div>
        </div>
    </div>
</div>


{% endblock %}

sample_taggit/library_management/templates/library_management/magazine_list.html
{% extends "library_management/base.html" %}

{% block title %}Magazine List{% endblock %}

{% block content %}
<h1 class="my-4">Magazines</h1>
<ul class="list-group">
    {% for magazine in magazines %}
        <li class="list-group-item">
            <a href="{% url 'magazine-detail' magazine.pk %}">{{ magazine.name }}</a>
        </li>
    {% endfor %}
</ul>
{% endblock %}

sample_taggit/library_management/templates/library_management/physical_copy_form.html
{% extends "library_management/base.html" %}

{% block title %}Update Physical Copy Condition{% endblock %}

{% block content %}
<h1>Update Physical Copy Condition</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <div class="button-group">
        <button type="submit" class="btn btn-primary">Save</button>
        <a href="{% url 'book-detail' object.book.pk %}" class="btn btn-secondary">Cancel</a>
    </div>
</form>
{% endblock %}